QGIS Application - Bug report #14153
loadNamedStyle fail to load edit widget
2016-01-21 05:58 AM - Peter Petrik

Status: Closed

Priority: Normal

Assignee:

Category: Edit widget

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 22155
Description

This code correctly loads style from gml file and adds layer 'test' to the map canvas (see attached zip file).
The QML file defines edit widget for attribute called 'attr' with the 'value map' type (see attached screenshot):

vl = QgsVectorLayer('test.shp', 'test', 'ogr')

QgsMapLayerRegistry.instance().addMapLayer(vl)
vl.loadNamedStyle('style.gml')

But this code doesn't load correct edit widget, just shows default "Text Edit' edit widget
vl = QgsVectorLayer('test.shp', 'test’, 'ogr')

vl.loadNamedStyle('style.qml’)
QgsMapLayerRegistry.instance().addMapLayer(vl)

Note: both codes correctly load renderer style

History

#1 - 2016-01-25 04:02 PM - Sebastian Dietrich
- Affected QGIS version changed from 2.10.1 to master

Widgets are loaded separately from the layers by QgsEditorWidgetRegistry. It watches the layers that are known to it and when a layer is loading a new

style, QgsEditorWidgetRegistry loads the widgets for that layer.
Unfortunately QgsEditorWidgetRegistry only knows of the layers that are added to QgsMapLayerRegistry. So the effect is as you describe: loading QML

after adding the layer works, loading QML before adding the layer does not.
The solution could be to simply make all (vector-)layers known to QgsEditorWidgetRegistry. But that might have other, probably unwanted, effects. | can't

tell.

#2 - 2017-05-01 01:06 AM - Giovanni Manghi
- Easy fix? set to No
- Regression? set to No

#3 - 2019-03-09 04:09 PM - Giovanni Manghi
- Resolution set to end of life
http://qgis.org/api/classQgsEditorWidgetRegistry.html
http://qgis.org/api/classQgsMapLayerRegistry.html

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/

Files

edit_bug.zip 3.89 KB 2016-01-21 Peter Petrik

edit_value_map.png 73.5KB 2016-01-21 Peter Petrik
